config/routes.rb
Rails.application.routes.draw do
  resources :line_items
  resources :carts
  resources :books
  devise_for :users
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  root "books#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/book.rb
class Book < ApplicationRecord
  belongs_to :user
  has_many :line_items, dependent: :destroy
  #before_destroy :ensure_not_referenced_by_any_line_item
  validates :title, presence: true
  mount_uploader :coverimage, PhotoUploader
  has_one_attached :pdf_file

  def ensure_not_referenced_by_any_line_item
    unless line_items.empty?
      errors.add(:base, "Line Items present")
      throw :abort
    end
  end
end

app/models/cart.rb
class Cart < ApplicationRecord
  has_many :line_items, dependent: :destroy

  def add_book(book)
    current_item = line_items.find_by(book_id: book.id)
    if current_item
      current_item.quantity += 1
    else
      current_item = line_items.build(book_id: book.id)
    end
    current_item
  end

  def total_price
    line_items.to_a.sum { |item| item.total_price }
  end
end

app/models/line_item.rb
class LineItem < ApplicationRecord
  belongs_to :book
  belongs_to :cart

  def total_price
    book.selling_price * quantity
  end
end

app/models/user.rb
class User < ApplicationRecord
  has_many :books
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception

  before_action :configure_permitted_parameters, if: :devise_controller?

  protected

  def configure_permitted_parameters
    devise_parameter_sanitizer.permit(:sign_up) { |u| u.permit(:name, :email, :password) }

    devise_parameter_sanitizer.permit(:account_update) { |u| u.permit(:name, :email, :password, :current_password) }
  end
end

app/controllers/books_controller.rb
class BooksController < ApplicationController
  before_action :set_book, only: [:show, :edit, :update, :destroy]

  # GET /books
  # GET /books.json
  def index
    @books = Book.all
  end

  # GET /books/1
  # GET /books/1.json
  def show
  end

  # GET /books/new
  def new
    @book = Book.new
  end

  # GET /books/1/edit
  def edit
  end

  # POST /books
  # POST /books.json
  def create
    @book = Book.new(book_params)
    @book.user = current_user
    respond_to do |format|
      if @book.save
        format.html { redirect_to @book, notice: "Book was successfully created." }
        format.json { render :show, status: :created, location: @book }
      else
        format.html { render :new }
        format.json { render json: @book.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /books/1
  # PATCH/PUT /books/1.json
  def update
    respond_to do |format|
      if @book.update(book_params)
        format.html { redirect_to @book, notice: "Book was successfully updated." }
        format.json { render :show, status: :ok, location: @book }
      else
        format.html { render :edit }
        format.json { render json: @book.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /books/1
  # DELETE /books/1.json
  def destroy
    @book.destroy
    respond_to do |format|
      format.html { redirect_to books_url, notice: "Book was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_book
    @book = Book.find(params[:id])
  end

  # Only allow a list of trusted parameters through.
  def book_params
    params.require(:book).permit(:title, :author_price, :selling_price, :book_index, :coverimage, :about, :book_category, :pdf_file, :youtube_link, :retired, :published, :user_id)
  end
end

app/controllers/carts_controller.rb
class CartsController < ApplicationController
  before_action :set_cart, only: [:show, :edit, :update, :destroy]
  rescue_from ActiveRecord::RecordNotFound, with: :invalid_cart

  # GET /carts
  # GET /carts.json
  def index
    @carts = Cart.all
  end

  # GET /carts/1
  # GET /carts/1.json
  def show
  end

  # GET /carts/new
  def new
    @cart = Cart.new
  end

  # GET /carts/1/edit
  def edit
  end

  # POST /carts
  # POST /carts.json
  def create
    @cart = Cart.new(cart_params)

    respond_to do |format|
      if @cart.save
        format.html { redirect_to @cart, notice: "Cart was successfully created." }
        format.json { render :show, status: :created, location: @cart }
      else
        format.html { render :new }
        format.json { render json: @cart.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /carts/1
  # PATCH/PUT /carts/1.json
  def update
    respond_to do |format|
      if @cart.update(cart_params)
        format.html { redirect_to @cart, notice: "Cart was successfully updated." }
        format.json { render :show, status: :ok, location: @cart }
      else
        format.html { render :edit }
        format.json { render json: @cart.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /carts/1
  # DELETE /carts/1.json
  def destroy
    @cart.destroy if @cart.id == session[:cart_id]
    session[:cart_id] = nil
    respond_to do |format|
      format.html { redirect_to root_path, notice: "You cart is empty." }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_cart
    @cart = Cart.find(params[:id])
  end

  # Only allow a list of trusted parameters through.
  def cart_params
    params.fetch(:cart, {})
  end

  def invalid_cart
    logger.error "Attempt to access invalid cart #{params[:id]}"
    redirect_to root_path, notice: "Invalid cart"
  end
end

app/controllers/concerns/current_cart.rb
module CurrentCart
    private
    def set_cart
        @cart=Cart.find(session[:cart_id])
    rescue ActiveRecord::RecordNotFound
        @cart=Cart.create
        session[:cart_id]=@cart.id
    end

end

app/controllers/line_items_controller.rb
class LineItemsController < ApplicationController
  include CurrentCart
  before_action :set_cart, only: [:create]
  before_action :set_line_item, only: [:show, :edit, :update, :destroy]

  # GET /line_items
  # GET /line_items.json
  def index
    @line_items = LineItem.all  
  end

  # GET /line_items/1
  # GET /line_items/1.json
  def show
  end

  # GET /line_items/new
  def new
    @line_item = LineItem.new
  end

  # GET /line_items/1/edit
  def edit
  end

  # POST /line_items
  # POST /line_items.json
  def create
    book = Book.find(params[:book_id])
    @line_item = @cart.add_book(book)

    respond_to do |format|
      if @line_item.save
        format.html { redirect_to @line_item.cart }
        format.json { render :show, status: :created, location: @line_item }
      else
        format.html { render :new }
        format.json { render json: @line_item.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /line_items/1
  # PATCH/PUT /line_items/1.json
  def update
    respond_to do |format|
      if @line_item.update(line_item_params)
        format.html { redirect_to @line_item, notice: "Line item was successfully updated." }
        format.json { render :show, status: :ok, location: @line_item }
      else
        format.html { render :edit }
        format.json { render json: @line_item.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /line_items/1
  # DELETE /line_items/1.json
  def destroy
    @line_item.destroy
    respond_to do |format|
      format.html { redirect_to line_items_url, notice: "Line item was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_line_item
    @line_item = LineItem.find(params[:id])
  end

  # Only allow a list of trusted parameters through.
  def line_item_params
    params.require(:line_item).permit(:book_id)
  end
end

app/controllers/pages_controller.rb
class PagesController < ApplicationController
  def index
    @books=Book.all.
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/books_helper.rb
module BooksHelper
end

app/helpers/carts_helper.rb
module CartsHelper
end

app/helpers/line_items_helper.rb
module LineItemsHelper
end

app/views/books/_form.html.erb
<%= form_with(model: book,class:"form-group", local: true) do |form| %>
  <% if book.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(book.errors.count, "error") %> prohibited this book from being saved:</h2>
      <ul>
        <% book.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
  <div class="field">
    <%= form.label :title, class:"label" %>
    <%= form.text_field :title,required: true, class: "form-control" %>
  </div>
  <div class="field">
    <%= form.label "Set price",class:"label" %>
    <%= form.text_field :author_price,class: "form-control" %>
  </div>
  <div class="field">
    <% form.label :selling_price,class:"label" %>
    <% form.text_field :selling_price,class: "form-control" %>
  </div>
  <div class="field">
    <%= form.label :book_index,class:"label" %>
    <%= form.text_area :book_index,class: "form-control"  %>
  </div>
  <div class="field">
    <%= form.label "Cover image",class:"label" %>
    <%= form.file_field :coverimage,class: "form-control"  %>
  </div>
  <div class="field">
    <%= form.label :about,class:"label" %>
    <%= form.text_area :about, rows:10, cols:60,class: "form-control"%>
  </div>
  <div class="field">
    <br>
    <%= form.label :book_category,class:"label" %>
    <% form.text_field :book_category,class: "form-control" %>
    <%= form.select :book_category, ['Biography', 'Technology','Science',"Fiction"], class: "form-control"%>
  </div>
  <div class="field">
    <%= form.label "upload book",class:"label" %>
    <%= form.file_field :pdf_file,class: "form-control" %>
  </div>
  <div class="field">
    <%= form.label :youtube_link,class:"label" %>
    <%= form.url_field :youtube_link,class: "form-control" %>
  </div>
  <div class="field">
    <%= form.label :retired,class:"label" %>
    <%= form.check_box :retired,class: "form-check" %>
  </div>
  <div class="field">
    <%= form.label :published,class:"label" %>
    <%= form.check_box :published,class: "form-check" %>
  </div>
  <div class="field">
    <%= form.hidden_field :user_id,class: "form-control", value: current_user.id%>
  </div>
  <br>
  <div class="actions">
    <%= form.submit "Create Book",class: "btn btn-outline-info btn-block" %>
  </div>
<% end %>

app/views/books/edit.html.erb
<h1>Editing Book</h1>
    
<%= render 'form', book: @book %>

<%= link_to 'Show', @book %> |
<%= link_to 'Back', books_path %>

app/views/books/index.html.erb
<p id="notice"><%= notice %></p>
<div class="whole_flex">
  <div class= "a">
    <div class="categories_title">
      <u>FREE BOOKS</u>
    </div>
    <div class="free_books">
      <div class="book_info">
        <% @books.each do |book| %>
          <div class="book_image">
            <div class="image_source">
              <img src=<%=book.coverimage_url%>>
            </div>
          </div>
          <div class="book_details">
            <div class="title_n_option">
              <div class="title">
                <%= book.title %>
              </div>
              <div class="options">
                <%= link_to 'Show', book, class: "btn btn-outline-dark" %>
              </div>
            </div>
            <div class="book_author">
              <%= book.user.name %>
            </div>
            <div class="about">
              <%=book.about%>
            </div>
            <br>
          </div>
        <%end%>
      </div>
    </div>
  </div>
  <div class="b">
    <div class="shelf">
      <div class="shelf_header">
        <u>THE SHELF</u>
      </div>
      <div class="shelf_content">
        THe carousel
        <% @books.each do |book| %>
          <div id="carouselExampleSlidesOnly" class="carousel slide carousel_slide" data-ride="carousel">
            <div class="carousel-inner">
              <div class="carousel-item active">
                <img class="d-block w-35" src=<%=book.coverimage_url %> alt="First slide">
              </div>
              <div class="carousel-item">
                <img class="d-block w-35" src=<%=book.coverimage_url%> alt="Second slide">
              </div>
              <div class="carousel-item">
                <img class="d-block w-35" src=<%=book.coverimage_url%> alt="Third slide">
              </div>
            </div>
          </div>
        <%end%>
      </div>
      <div class="Book_list">
        <div class="div_header">
          <u>TOP BOOKS</u>
        </div>
        <div class="book_info">
          <% @books.each do |book| %>
            <div class="book_image">
              <div class="image_source">
                <img src=<%=book.coverimage_url%>>
              </div>
            </div>
            <div class="book_details">
              <div class="title_n_option">
                <div class="title">
                  <%= book.title %>
                </div>
                <div class="options">
                  <%= link_to 'Show', book, class: "btn btn-outline-dark" %>
                  <% if current_user==book.user %>
                    <%= link_to 'Edit', edit_book_path(book),class: "btn btn-outline-warning" %>
                    <%= link_to 'Destroy', book, method: :delete, data: { confirm: 'Are you sure?' }, class:"btn btn-outline-danger" %>
                  <% end %>
                </div>
              </div>
              <div class="book_author">
                <%= book.user.name %>
              </div>
              <div class="about">
                <%=book.about%>
              </div>
              <br>
            </div>
          <%end%>
        </div>
      </div>
    </div>
  </div>
  <!--
<table>
  <thead>
    <tr>
      <th>Title</th>
      <th>Book index</th>
      <th>About</th>
      <th>Book category</th>
      <th>Youtube link</th>
      <th>Retired</th>
      <th>Published</th>
      <th>Author</th>
      <th colspan="3"></th>
    </tr>
  </thead>
  <tbody>
    <% @books.each do |book| %>
      <tr>
        <td><%= book.title %></td>
        <td><%= book.book_index %></td>
        <td><%= book.about %></td>
        
        <td><%= book.user.name %></td>
        <td><%= link_to 'Show', book %></td>
        <% if current_user==book.user %>
          <td><%= link_to 'Edit', edit_book_path(book) %></td>
          <td><%= link_to 'Destroy', book, method: :delete, data: { confirm: 'Are you sure?' } %></td>
        </tr>
      <% end %>
    <% end %>
  </tbody>
</table>
<br>
<% if current_user %>
  <%= link_to 'New Book', new_book_path %>
<% else %>
  <%= link_to "New Book", new_user_session_path%>
<% end %>
-->

app/views/books/new.html.erb
<div class="container align-item-center ">
  <h1 class="title">New Book</h1>
  <br>
  <div class="contain">
    <%= render 'form', book: @book %>
    <%= link_to '<<GO Back', books_path,class:"btn btn-danger" %>
    <br>
    <br>
  </div>
</div>

app/views/books/show.html.erb
<p id="notice"><%= notice %></p>
<p>
  <strong>Title:</strong>
  <%= @book.title %>
  <%=@book.id%>
</p>
<p>
  <strong>Author price:</strong>
  <%= @book.author_price %>
</p>
<p>
  <strong>Selling price:</strong>
  <%= @book.selling_price %>
</p>
<p>
  <strong>Coverimage:</strong>
  <img src=<%=@book.coverimage_url%>>
</p>
<p>
  <strong>Book index:</strong>
  <%= @book.book_index %>
</p>
<p>
  <strong>About:</strong>
  <%= @book.about %>
</p>
<p>
  <strong>file:</strong>
  <%#=link_to "download",@book.pdf_file.download%>
</p>
<p>
  <strong>Book category:</strong>
  <%= @book.book_category %>
</p>
<p>
  <strong>Youtube link:</strong>
  <%= @book.youtube_link %>
</p>
<p>
  <strong>Retired:</strong>
  <%= @book.retired %>
</p>
<p>
  <strong>Published:</strong>
  <%= @book.published %>
</p>
<p>
  <strong>User:</strong>
  <%= @book.user_id %>
</p>
<%= link_to 'Edit', edit_book_path(@book) %> |
<%= link_to 'Back', books_path %>
<%= button_to "Add to cart", line_items_path(book_id: @book)%>

app/views/carts/_form.html.erb
<%= form_with(model: cart, local: true) do |form| %>
  <% if cart.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(cart.errors.count, "error") %> prohibited this cart from being saved:</h2>

      <ul>
        <% cart.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/carts/edit.html.erb
<h1>Editing Cart</h1>

<%= render 'form', cart: @cart %>

<%= link_to 'Show', @cart %> |
<%= link_to 'Back', carts_path %>

app/views/carts/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Carts</h1>

<table>
  <thead>
    <tr>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @carts.each do |cart| %>
      <tr>
        <td><%= link_to 'Show', cart %></td>
        <td><%= link_to 'Edit', edit_cart_path(cart) %></td>
        <td><%= link_to 'Destroy', cart, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Cart', new_cart_path %>

app/views/carts/new.html.erb
<h1>New Cart</h1>

<%= render 'form', cart: @cart %>

<%= link_to 'Back', carts_path %>

app/views/carts/show.html.erb
<article>
  <% if notice %>
    <aside id="notice"><%=notice%></aside>
  <% end %>
  <table>
    <h2>Your Cart</h2>
    <% @cart.line_items.each do |line_item|%>
      <tr>
        <td class= "quantity"><%= line_item.quantity%></td>
        <td class="title"><%=line_item.book.title%></td>
        <td class="price"><%=number_to_currency(line_item.total_price)%></td>
      </tr>
    <%end%>
    <tfoot>
      <tr>
        <th colspan="2">Total:</th>
        <td class="price"><%=number_to_currency(@cart.total_price)%></td>
      </tr>
    </tfoot>
  </table>
  <ul>
    <% @cart.line_items.each do |item|%>
      <li><%= item.quantity%> &times; <%= item.book.title%> </li>
    <%end%>
  </ul>
  <%= button_to "Empty cart",@cart, method: :delete, data: {confirm: "Are you sure?"}%>
</article>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Leanpub</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>
  <body>
    <header>
      <%= render 'shared/navbar' %>
    </header>
    <%= yield %>
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
  </body>
</html>

app/views/line_items/_form.html.erb
<%= form_with(model: line_item, local: true) do |form| %>
  <% if line_item.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(line_item.errors.count, "error") %> prohibited this line_item from being saved:</h2>

      <ul>
        <% line_item.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :book_id %>
    <%= form.text_field :book_id %>
  </div>

  <div class="field">
    <%= form.label :cart_id %>
    <%= form.text_field :cart_id %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/line_items/edit.html.erb
<h1>Editing Line Item</h1>

<%= render 'form', line_item: @line_item %>

<%= link_to 'Show', @line_item %> |
<%= link_to 'Back', line_items_path %>

app/views/line_items/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Line Items</h1>

<table>
  <thead>
    <tr>
      <th>Book</th>
      <th>Cart</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @line_items.each do |line_item| %>
      <tr>
        <td><%= line_item.book_id %></td>
        <td><%= line_item.cart_id %></td>
        <td><%= link_to 'Show', line_item %></td>
        <td><%= link_to 'Edit', edit_line_item_path(line_item) %></td>
        <td><%= link_to 'Destroy', line_item, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Line Item', new_line_item_path %>

app/views/line_items/new.html.erb
<h1>New Line Item</h1>

<%= render 'form', line_item: @line_item %>

<%= link_to 'Back', line_items_path %>

app/views/line_items/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Book:</strong>
  <%= @line_item.book_id %>
</p>

<p>
  <strong>Cart:</strong>
  <%= @line_item.cart_id %>
</p>

<%= link_to 'Edit', edit_line_item_path(@line_item) %> |
<%= link_to 'Back', line_items_path %>

app/views/pages/index.html.erb
<% if user_signed_in? %>
  <%= link_to "logout", destroy_user_session_path, method: :delete %>
<%else%>
  <%= link_to "sign in", new_user_session_path %>
  <%= link_to "sign up", new_user_registration_path %>
<% end %>

app/views/shared/_navbar.html.erb
<nav class="navbar navbar-expand-lg navbar-light">
  <div class="container">
    <%= link_to root_path do%>
      <%= image_tag "icon.png", class: "navbar-brand core-sprite hide-text"%>
    <% end %>
    <a class="nav-link notification-icon hide-text" href="#">Books</a>
    <a class="nav-link explore-icon hide-text" href="#">Bundles</a>
    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <%= form_with url: "users/", method: :get,class: "form-inline my-2 my-lg-0 searchbar", id: "users-search" do |form| %>
        <%= form.text_field :term, class: "form-control mr-sm-2 text-center",placeholder: "search"   %>
        <div id="books-result">
        </div>
        <!--
        <form class="form-inline my-2 my-lg-0 ml-md-auto">
        <input class="form-control mr-sm-2 text-center" type="search" placeholder="Search" aria-label="Search">
      </form> -->
      <% end %>
      <div class="dropdown">
        <button class="dropbtn">&#9776</button>
        <div class="dropdown-content">
          <% if user_signed_in? %>
            <%= link_to "Create Book", new_book_path%>
            <%=current_user.email%>
            <%= link_to "Email-settings", edit_user_registration_path(current_user), class: "nav-item profile-icon hide-text"%>
            <%= link_to "logout", destroy_user_session_path, method: :delete, class: "no-text-decoration" %>
          <%else%>
            <%= link_to "sign in", new_user_session_path %>
            <%= link_to "sign up", new_user_registration_path %>
          <% end %>
          <a class="nav-item  wishlist-icon" href="#">wishlist</a>
        </div>
      </div>
    </div>
  </div>
</nav>